using System.Collections.Generic;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Media.Animation;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ī  ¡ Լ Ʈ
        /// </summary>
        public List<NamedEasingFunction> NamedEasingFunctionList { get; } = new List<NamedEasingFunction>()
        {
            new NamedEasingFunction("BackEase"       , new BackEase()       ),
            new NamedEasingFunction("BounceEase"     , new BounceEase()     ),
            new NamedEasingFunction("CircleEase"     , new CircleEase()     ),
            new NamedEasingFunction("CubicEase"      , new CubicEase()      ),
            new NamedEasingFunction("ElasticEase"    , new ElasticEase()    ),
            new NamedEasingFunction("ExponentialEase", new ExponentialEase()),
            new NamedEasingFunction("PowerEase"      , new PowerEase()      ),
            new NamedEasingFunction("QuadraticEase"  , new QuadraticEase()  ),
            new NamedEasingFunction("QuarticEase"    , new QuarticEase()    ),
            new NamedEasingFunction("QuinticEase"    , new QuinticEase()    ),
            new NamedEasingFunction("SineEase"       , new SineEase()       )
        };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.animateButton1.Click  += animateButton1_Click;
            this.animateButton2.Click  += animateButton2_Click;
            this.animateButton3.Click  += animateButton3_Click;
            this.animateButton4.Click  += animateButton4_Click;
            this.easingComboBox.Loaded += easingComboBox_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Animate ư 1 Ŭ óϱ - animateButton1_Click(sender, e)

        /// <summary>
        /// Animate ư 1 Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void animateButton1_Click(object sender, RoutedEventArgs e)
        {
            this.storyboard1.Children[0].SetValue(DoubleAnimation.FromProperty, this.translationTransform1.X              );
            this.storyboard1.Children[0].SetValue(DoubleAnimation.ToProperty  , this.translationTransform1.X > 0 ? 0 : 200);

            this.storyboard1.Begin();
        }

        #endregion
        #region Animate ư 2 Ŭ óϱ - animateButton2_Click(sender, e)

        /// <summary>
        /// Animate ư 2 Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void animateButton2_Click(object sender, RoutedEventArgs e)
        {
            this.storyboard2.Children[0].SetValue(DoubleAnimation.FromProperty, this.translateTransform2.X              );
            this.storyboard2.Children[0].SetValue(DoubleAnimation.ToProperty  , this.translateTransform2.X > 0 ? 0 : 200);

            this.storyboard2.Begin();
        }

        #endregion
        #region Animate ư 3 Ŭ óϱ - animateButton3_Click(sender, e)

        /// <summary>
        /// Animate ư 3 Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void animateButton3_Click(object sender, RoutedEventArgs e)
        {
            this.storyboard3.Children[0].SetValue(DoubleAnimation.FromProperty, this.translateTransform3.X              );
            this.storyboard3.Children[0].SetValue(DoubleAnimation.ToProperty  , this.translateTransform3.X > 0 ? 0 : 200);

            this.storyboard3.Begin();
        }

        #endregion
        #region Animate ư 4 Ŭ óϱ - animateButton4_Click(sender, e)

        /// <summary>
        /// Animate ư 4 Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void animateButton4_Click(object sender, RoutedEventArgs e)
        {
            EasingFunctionBase easingFunctionBase = this.easingComboBox.SelectedValue as EasingFunctionBase;

            easingFunctionBase.EasingMode = GetEasingMode();

            (this.storyboard4.Children[0] as DoubleAnimation).EasingFunction = easingFunctionBase;

            this.storyboard4.Children[0].SetValue(DoubleAnimation.FromProperty, this.translateTransform4.X              );
            this.storyboard4.Children[0].SetValue(DoubleAnimation.ToProperty  , this.translateTransform4.X > 0 ? 0 : 200);

            this.storyboard4.Begin();
        }

        #endregion
        #region ¡ ޺ ڽ ε óϱ - easingComboBox_Loaded(sender, e)

        /// <summary>
        /// ¡ ޺ ڽ ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void easingComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            this.easingComboBox.SelectedIndex = 0;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ¡  ϱ - GetEasingMode()

        /// <summary>
        /// ¡  ϱ
        /// </summary>
        /// <returns>¡ </returns>
        private EasingMode GetEasingMode()
        {
            if(this.easeOutRadioButton.IsChecked == true)
            {
                return EasingMode.EaseOut;
            }
            else if(this.easeInRadioButton.IsChecked == true)
            {
                return EasingMode.EaseIn;
            }
            else
            {
                return EasingMode.EaseInOut;
            }
        }

        #endregion
    }
}